Welcome to Subscribe On Youtube

Question

Formatted question description: https://leetcode.ca/all/299.html

You are playing the Bulls and Cows game with your friend.

You write down a secret number and ask your friend to guess what the number is. When your friend makes a guess, you provide a hint with the following info:

  • The number of "bulls", which are digits in the guess that are in the correct position.
  • The number of "cows", which are digits in the guess that are in your secret number but are located in the wrong position. Specifically, the non-bull digits in the guess that could be rearranged such that they become bulls.

Given the secret number secret and your friend's guess guess, return the hint for your friend's guess.

The hint should be formatted as "xAyB", where x is the number of bulls and y is the number of cows. Note that both secret and guess may contain duplicate digits.

 

Example 1:

Input: secret = "1807", guess = "7810"
Output: "1A3B"
Explanation: Bulls are connected with a '|' and cows are underlined:
"1807"
  |
"7810"

Example 2:

Input: secret = "1123", guess = "0111"
Output: "1A1B"
Explanation: Bulls are connected with a '|' and cows are underlined:
"1123"        "1123"
  |      or     |
"0111"        "0111"
Note that only one of the two unmatched 1s is counted as a cow since the non-bull digits can only be rearranged to allow one 1 to be a bull.

 

Constraints:

  • 1 <= secret.length, guess.length <= 1000
  • secret.length == guess.length
  • secret and guess consist of digits only.

Algorithm

Two traversals, the first traversal finds all numbers with the same position and the same value, that is, bulls, and records the number of times that the numbers in the secret are not bulls. Then we traverse for the second time for the position that is not bulls in guess. If it exists in the hash table, cows increments by 1, and then the mapping value is reduced by 1.

To improve, it can be done with a single loop. When dealing with positions that are not bulls,

  • If the mapping value of the current position of the secret is less than 0, it means that it has appeared in guess, cows is incremented by 1, and then the mapping value is incremented by 1.
  • If the mapping value of the number at the current position of guess is greater than 0, it means that it has appeared in secret, cows is incremented by 1, and then the mapping value is reduced by 1.

Code

  • 
    public class Bulls_and_Cows {
    
    
        public class Solution {
            public String getHint(String secret, String guess) {
                if (secret == null || secret.length() == 0 ||
                    guess == null || guess.length() == 0) {
                    return "0A0B";
                }
    
                int numBulls = 0;
                int numCows = 0;
    
                int[] hm = new int[256];
    
                // Step 1: calculate the number of bulls and update the hm
                for (int i = 0; i < secret.length(); i++) {
                    char s = secret.charAt(i);
                    char g = guess.charAt(i);
    
                    if (s == g) {
                        numBulls++;
                    } else {
                        if (hm[s] < 0) {
                            numCows++;
                        }
                        hm[s]++;
    
                        if (hm[g] > 0) {
                            numCows++;
                        }
                        hm[g]--;
                    }
                }
    
                return numBulls + "A" + numCows + "B";
            }
        }
    }
    
    ############
    
    class Solution {
        public String getHint(String secret, String guess) {
            int x = 0, y = 0;
            int[] cnt1 = new int[10];
            int[] cnt2 = new int[10];
            for (int i = 0; i < secret.length(); ++i) {
                int a = secret.charAt(i) - '0', b = guess.charAt(i) - '0';
                if (a == b) {
                    ++x;
                } else {
                    ++cnt1[a];
                    ++cnt2[b];
                }
            }
            for (int i = 0; i < 10; ++i) {
                y += Math.min(cnt1[i], cnt2[i]);
            }
            return String.format("%dA%dB", x, y);
        }
    }
    
  • // OJ: https://leetcode.com/problems/bulls-and-cows/
    // Time: O(N)
    // Space: O(1)
    class Solution {
    public:
        string getHint(string secret, string guess) {
            int N = secret.size(), bull = 0, cow = 0, secretCnt[10] = {}, guessCnt[10] = {};
            for (int i = 0; i < N; ++i) {
                if (secret[i] == guess[i]) ++bull;
                else {
                    secretCnt[secret[i] - '0']++;
                    guessCnt[guess[i] - '0']++;
                } 
            }
            for (int i = 0; i < 10; ++i) cow += min(secretCnt[i], guessCnt[i]);
            return to_string(bull) + "A" + to_string(cow) + "B";
        }
    };
    
  • class Solution:
        def getHint(self, secret: str, guess: str) -> str:
            x = y = 0
            cnt1 = [0] * 10
            cnt2 = [0] * 10
            for i in range(len(secret)):
                if secret[i] == guess[i]:
                    x += 1
                else:
                    cnt1[int(secret[i])] += 1
                    cnt2[int(guess[i])] += 1
    
            for i in range(10):
                y += min(cnt1[i], cnt2[i])
            return f'{x}A{y}B'
    
    ############
    
    from collections import Counter
    
    
    class Solution(object):
      def getHint(self, secret, guess):
        """
        :type secret: str
        :type guess: str
        :rtype: str
        """
        a = b = 0
        ds = Counter()
        dg = Counter()
        for i in range(len(secret)):
          s = secret[i]
          g = guess[i]
          if secret[i] == guess[i]:
            a += 1
          else:
            ds[s] += 1
            dg[g] += 1
            if ds[g] > 0:
              b += 1
              dg[g] -= 1
              ds[g] -= 1
            if dg[s] > 0:
              b += 1
              ds[s] -= 1
              dg[s] -= 1
        return "{}A{}B".format(a, b)
    
    
  • func getHint(secret string, guess string) string {
    	x, y := 0, 0
    	cnt1 := make([]int, 10)
    	cnt2 := make([]int, 10)
    	for i := 0; i < len(secret); i++ {
    		a, b := secret[i]-'0', guess[i]-'0'
    		if a == b {
    			x++
    		} else {
    			cnt1[a]++
    			cnt2[b]++
    		}
    	}
    	for i := 0; i < 10; i++ {
    		y += min(cnt1[i], cnt2[i])
    	}
    	return fmt.Sprintf("%dA%dB", x, y)
    }
    
    func min(a, b int) int {
    	if a < b {
    		return a
    	}
    	return b
    }
    
  • class Solution {
        /**
         * @param String $secret
         * @param String $guess
         * @return String
         */
        function getHint($secret, $guess) {
            $cntA = 0;
            $cntB = 0;
            $len = strlen($secret);
            for ($i = 0; $i < $len; $i++) {
                if ($secret[$i] == $guess[$i]) $cntA++;
                else $hashtable[$secret[$i]] += 1;
            }
            for ($i = 0; $i < $len; $i++) {
                if ($secret[$i] != $guess[$i] && $hashtable[$guess[$i]] > 0) {
                    $cntB++;
                    $hashtable[$guess[$i]] -= 1;
                }
            }
            return $cntA."A".$cntB."B";
        }
    }
    

All Problems

All Solutions